; Matrix code simulator on 86

.nolist
#define equ .equ
#include "asm86.h"
#include "Asm86.inc"
#include "Ram86.inc"
.list


.org _asm_exec_ram

lblStart:
	call	_runindicoff
	
	ld	hl,tempram
	ld	de,tempram+1
	ld	(hl),$00
	ld	bc,320
	ldir

	ld	hl,$FC00
	ld	de,$FC01
	ld	(hl),$00
	ld	bc,1023
	ldir
	
	
	

	call	BlackBuffer
		
	
	ld	hl,MatrixStr
	ld	de,$1C29
	call	SetVput
	
	ld	b,200
	call	delayb

LoopGeneral:

	call	UpdateFirstLine
	
	call	D_ZC_Screen	

	ld	hl,_plotSScreen
	ld	de,$FC00
	ld	bc,1024
	ldir

	call	DownBuffer


    ld a,%00111111
    out (1),a
    nop
    nop
    in a,(1)
    bit 6,a
	jp	z,Xit

	
Continue:	
	jp	LoopGeneral
		
Xit:
	call	_flushAllMenus
	call	_clrlcd
		call	_runindicon

	set graphdraw,(IY+graphflags)	
	ret

UpdateFirstLine:
	ld	bc,32
	ld	hl,textshadowmatrix-1
UpdateLoop:	
	push	bc
	push	hl


		add	hl,bc	; current row calulated

	
ScrolingOffset = $+1	
	ld	b,2
	call	ionrandom
	dec	a	\	jr	z,UpdateEnd		


	call	SearchForABlock

	call	CalculateLastPosition


	ld	b,$25
	call	ionrandom
	
	ld	(hl),a

UpdateEnd:
	pop	hl
	pop	bc
	dec	c
	jr	nz,UpdateLoop
	
	ret	
	

CalculateLastPosition:
	
;	ld	a,2
;	call	ionrandom
;	jr	z, $+3
	ld	(temp),hl
	ld	b,0

CalcLoop:	
	ld	a,(hl)
	or	a	\	ret	z
	ld	de,32
	add	hl,de
	inc	b
	ld	a,b
	cp	9	\	jr	z,EndCalcLoop
	jr	CalcLoop	

EndCalcLoop:
	ld	hl,(temp)	
	ret
	
SearchForABlock:
	ld	b,0
	ld	(temp),hl

SearchLoop:	
		
	ld	a,(hl)
	or	a	\	ret	nz
	ld	de,32
	add	hl,de
	inc	b
	ld	a,b
	cp	9
	jr	z,SearchEnd
	jr	SearchLoop	

SearchEnd:
	ld	hl,(temp)
	ret

SetVput:
	ld	(_penCol),de
	call	_vputs
	ret

D_ZC_Screen:
	call BlackBuffer
	ld	hl,textshadowmatrix
	ld	bc,$0002				;initial position
	
D_ZC_ScreenLoop:	
	ld	a,(hl)	
	call	C_CHARPUT
	ld	a,b
	inc	hl
	cp	128
	jr	nz,D_ZC_ScreenLoop
	
	ld	a,6
	add	a,c
	cp	62		\	ret	z
	ld	c,a
	
	ld	b,0
	jr	D_ZC_ScreenLoop
	

BlackBuffer:
	ld	hl,_plotSScreen
	ld	de,_plotSScreen+1
	ld	(hl),11111111b
BlackValue = $-1

	ld	bc,1023
	ldir
	ret
	
;Routine de pour descendre le buffer
DownBuffer:	

	ld	b,32

DownBufLoop:
	push	bc		 
	ld	hl,textshadowmatrix+(8*32)-1
	ld	de,textshadowmatrix+(9*32)-1

	ld	c,b
	ld	b,0
	
	ex	de,hl
	add	hl,bc
	ex	de,hl
	add	hl,bc	
	
	ld	b,3
	call	ionrandom
	dec	a	\	jr	z,Columdontmove
	
	ld	b,9
DownColLoop:	
	push	bc
	ld	a,(hl)
	ld	(de),a
;	ldi
	
	ex	de,hl
	
	ld	bc,32
	or	a
	sbc	hl,bc
	
	ex	de,hl
	or	a
	sbc	hl,bc
	
	pop	bc
	djnz	DownColLoop

	ex	de,hl
	ld	(hl),0	

Columdontmove:	
	pop	bc
	djnz	DownBufLoop	
	
	
	ret

; Routine de delay
delayb:
	ei
	halt
	djnz delayb
	ret	
	
;----------(Direct_Input Routine v1.0)----------;
; Input:  B = The Key Port Value to be Checked. ;
; Output: A = Key Value / State of the Keyport. ;
;-----------------------------------------------;

MatrixStr:
	.db "The Matrix",0

#include "CCHARPUT.inc"

ionrandom:
	push	hl
	push	de
	ld	hl,(randData)
	ld	a,r
	ld	d,a
	ld	e,(hl)
	add	hl,de
	add	a,l
	xor	h
	ld	(randData),hl
	sbc	hl,hl
	ld	e,a
	ld	d,h
randomLoop:
	add	hl,de
	djnz	randomLoop
	ld	a,h
	pop	de
	pop	hl
	ret
	


tempram = $
textshadowmatrix = tempram		;[240] Buffer sur lequel les caractere de la matrice vont etre storer
temp	= tempram+320
randData = tempram+322

.end
.end
